## camitk 4.0.4

=== CMakeLists.txt ===
#--------------------------------------------
#
#         CamiTK Open Source CEP Set
#
#--------------------------------------------
cmake_minimum_required(VERSION 3.0)

project(camitkopensource)

# Allow testing of the whole camitk-opensource project
include(CTest)
enable_testing()

# Specific to SDK: control the version (major, minor, default patch and )
set(CAMITK_PROJECT_NAME "CamiTK")
set(CAMITK_VERSION_MAJOR "4")
set(CAMITK_VERSION_MINOR "0")
set(CAMITK_VER_NICKNAME "red") # Red Amaranth American rose Auburn Burgundy Cardinal Carmine Carnelian Cerise Coquelicot
set(CAMITK_VERSION_PATCH "4") # patch version for packaging, change when appropriate
string(TOLOWER "${CAMITK_PROJECT_NAME}-${CAMITK_VERSION_MAJOR}.${CAMITK_VERSION_MINOR}" CAMITK_SHORT_VERSION_STRING)

# Specific to SDK: this is the SDK build
set(CAMITK_SDK_BUILD TRUE)

#-- This is a CEP set...
set(CAMITK_EXTENSION_PROJECT_SET TRUE CACHE BOOL "Is this a CamiTK Extension Project Set?")
set(CAMITK_EXTENSION_PROJECT_SET_NAME "camitk-opensource" CACHE STRING "CEP Set Name")

# Configure CamiTK Opensource packaging.
# Must be done before parsing extensions CMakeLists.txt files.
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/sdk/cmake/modules/macros)
set(CAMITK_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
include(camitk/packaging/CamiTKOpenSourcePackaging)
camitk_opensource_packaging()

# CamiTK 4.0 is C++11 compliant
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

# Specific to SDK: first compile the SDK (it looks like a CEP but is sooooo special...)
add_subdirectory(sdk)

# ...composed by the following CamiTK Extension Projects
add_subdirectory(imaging)
add_subdirectory(modeling)

# Do we wrapp CamiTK for scripting it into Python using Shiboken and PySide ?
set(CAMITK_BINDING_PYTHON CACHE BOOL FALSE)

# Consider python binding only if the CMake variable is checked
if(CAMITK_BINDING_PYTHON)
    add_subdirectory(python_sdk)
endif()

camitk_sub_project_validate(CEP_SET)

=== modeling/CMakeLists.txt ===
#--------------------------------------------
# Modeling extension project
#--------------------------------------------
# Mini find CamiTK inside SDK
set(CAMITK_DIR ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CAMITK_DIR}/share/${CAMITK_SHORT_VERSION_STRING}/cmake)
include(CamiTKConfig)

# Sofa support is defined in separate files
include(SofaSupport.cmake)
# uncomment the following line for old versions of sofa: at your own risk!
#include(SofaLegacySupport.cmake) 

# For packaging on windows, dash cannot be used as separator
# => replace it by underscore
if (PACKAGING_NSIS)
    set(TARGET_NAME_SEPARATOR _)
else()
    set(TARGET_NAME_SEPARATOR -)
endif()

camitk_extension_project(NAME "modeling"
                         CONTACT "Celine.Fouard@imag.fr,Emmanuel.Promayon@imag.fr"
                         DESCRIPTION "The modeling CamiTK Extension Project contains all the action and component extensions that are useful for biomechanical processing. It provides the LML, PML and MML libraries, and the related components and actions."
)

=== python_sdk/CMakeLists.txt ===
#--------------------------------------------
#
#         CamiTK SDK Python binding 
#
#              Do not edit this file, unless
#              you really (really!) know
#              what you're doing
#
#--------------------------------------------


#--------------------------------------------
#
# Python binding requirements
#
#--------------------------------------------
# First of all needs : Python
find_package(PythonLibs REQUIRED)
# Then the Shiboken tool, the PySide team C++ to Python wrapper
find_package(Shiboken REQUIRED)
find_program(CAMITK_BINDING_PYTHON_GENERATOR shiboken REQUIRED)
if (NOT CAMITK_BINDING_PYTHON_GENERATOR)
    message(FATAL_ERROR "Please add Shiboken binary in your PATH or manually point to it using the CAMITK_BINDING_PYTHON_GENERATOR variable")
endif()

# And of course Qt and PySide, the Python binding of Qt (4.8) using Shiboken.
find_package(Qt4 REQUIRED)
find_package(PySide REQUIRED)

# TEST Using VTK dependency 
find_package(VTK REQUIRED)

#--------------------------------------------
#
# Recursively parse subdirectories for classes to expose
#
#--------------------------------------------
# Shiboken PATH to look for typesystem.xml and global.h files, recursively udapted
set(SHIBOKEN_TYPESYSTEM_PATH ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
set(SHIBOKEN_GLOBAL_H_PATH ${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")

# include subdirectories
add_subdirectory(actions)
add_subdirectory(applications)
add_subdirectory(components)
add_subdirectory(libraries)

# TODO : Remove once debugged
# message(WARNING "PYSIDE_INCLUDE_DIR = ${PYSIDE_INCLUDE_DIR}")
# message(WARNING "SHIBOKEN_TYPESYSTEM_PATH = ${SHIBOKEN_TYPESYSTEM_PATH}")
# message(WARNING "SHIBOKEN_GLOBAL_H_PATH = ${SHIBOKEN_GLOBAL_H_PATH}")
# message(WARNING "QT_INCLUDE_DIR = ${QT_INCLUDE_DIR}")
# message(WARNING "QT_QTCORE_INCLUDE_DIR = ${QT_QTCORE_INCLUDE_DIR}")
# message(WARNING "SHIBOKEN_CAMITK_SDK_PATH = ${SHIBOKEN_CAMITK_SDK_PATH}")
# message(WARNING "VTK_INCLUDE_DIRS = ${VTK_INCLUDE_DIRS}")

#--------------------------------------------
#
# Custom CMake Python binding targets
#
#--------------------------------------------
# Shiboken specific paths
set(PYSIDE_INCLUDE_ALL_DIR_SHIBOKEN
    ${PYSIDE_INCLUDE_DIR}:${PYSIDE_INCLUDE_DIR}/QtCore:${PYSIDE_INCLUDE_DIR}/QtGui
    #:${PYSIDE_INCLUDE_DIR}/QtHelp:${PYSIDE_INCLUDE_DIR}/QtNetwork:${PYSIDE_INCLUDE_DIR}/QtOpenGL:${PYSIDE_INCLUDE_DIR}/QtScript:${PYSIDE_INCLUDE_DIR}/QtScriptTools:${PYSIDE_INCLUDE_DIR}/QtSql:${PYSIDE_INCLUDE_DIR}/QtSvg:${PYSIDE_INCLUDE_DIR}/QtTest:${PYSIDE_INCLUDE_DIR}/QtUiTools:${PYSIDE_INCLUDE_DIR}/QtWebKit:${PYSIDE_INCLUDE_DIR}/QtXml:${PYSIDE_INCLUDE_DIR}/QtXmlPatterns:${PYSIDE_INCLUDE_DIR}/QtDeclarative
)

# TODO : Remove once debugged
# message(WARNING "PYSIDE_INCLUDE_ALL_DIR_SHIBOKEN = ${PYSIDE_INCLUDE_ALL_DIR_SHIBOKEN}")

# Wrap the CamiTK SDK. Wrapping uses Shiboken (PySide binding tool)
# It means it decorates the specified C++ classes to Python by adding 
# information in order to convert it into a CPython extension
# Shiboken parses the typesystem.xml files to detect which C++ classes to expose to Python
# For each of them, it create a CPython C++ decorated class in the build directory
add_custom_target(  sdk_wrap_to_python
#                     OUTPUT ${lib_python_SRC}
                    COMMAND ${CMAKE_COMMAND} -E echo "Cleaning C++ classes generated from previous wrapping."    
                    COMMAND ${CMAKE_COMMAND} -E remove_directory camitk_sdk
                    COMMAND ${CMAKE_COMMAND} -E echo "Wrapping CamiTK SDK for Python exposure."    
                    COMMAND ${CAMITK_BINDING_PYTHON_GENERATOR} --enable-parent-ctor-heuristic --enable-return-value-heuristic --enable-pyside-extensions #--debug-level=full
                    ${CMAKE_CURRENT_SOURCE_DIR}/global_sdk.h
                    --include-paths=${PYSIDE_INCLUDE_ALL_DIR_SHIBOKEN}:${QT_INCLUDE_DIR}:${QT_QTCORE_INCLUDE_DIR}:${SHIBOKEN_GLOBAL_H_PATH}:${SHIBOKEN_CAMITK_SDK_PATH}:${VTK_INCLUDE_DIRS}
                    --typesystem-paths=${PYSIDE_TYPESYSTEMS}:${SHIBOKEN_TYPESYSTEM_PATH}
                    --output-directory=${CMAKE_CURRENT_BINARY_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}/typesystem_sdk.xml
#                     WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
#                     COMMENT "Running generator for ${PROJECT_NAME}:"
                    COMMAND ${CMAKE_COMMAND} -E echo "CamiTK SDK wrapped." 
                  )
                  
# The resulting C++ wrapped classes will be listed in the following CMake variable:
file(GLOB_RECURSE SDK_WRAPPED_CLASSES ${CMAKE_BINARY_DIR}/python_sdk/camitk_sdk/*.cpp )

# We list the CamiTK SDK generated dynamic libraries for linking the python package
# TODO do not manually list those libraries, but dynamically create this list at configuration
# step, using CamiTK CMake macros
file(GLOB_RECURSE CAMITK_SDK_LIBRARIES ${CMAKE_BINARY_DIR}/*.so)
# message(WARNING "CAMITK_SDK_LIBRARIES = ${CAMITK_SDK_LIBRARIES}")

# This CMake target aims at compiling the C++ Python-wrapped classes of CamiTK and link them against
# the original CamiTK SDK libraries.
# WARNING Do not manually run this target, it requires another configure step wich is run by the sdk_package_to_python
# CMake target.
if(NOT SDK_WRAPPED_CLASSES STREQUAL "") # only create camitk_sdk target if camitk sdk has been wrapped
    set(PROJECT_NAME camitk_sdk) # the name of the camitk sdk package once compiled
    string(REPLACE ":" ";" CAMITK_SDK_INCLUDE_DIR ${SHIBOKEN_CAMITK_SDK_PATH}) # deduce the list of include directories of CamiTK SDK
    string(REPLACE ":" ";" PYSIDE_INCLUDE_ALL_DIR ${PYSIDE_INCLUDE_ALL_DIR_SHIBOKEN}) #deduce the list of include directories provided from PySide / Shiboken
    # Qt libraries dependencies
    set(QT_LIBRARIES "${QT_QTCORE_LIBRARY};${QT_QTGUI_LIBRARY}")
#     message(WARNING "QT_LIBRARIES = ${QT_LIBRARIES}")
    set(CAMITK_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR}/../sdk/libraries/core
                        ${CMAKE_CURRENT_BINARY_DIR}/../sdk/actions/mesh/basicmesh 
                        ${CMAKE_CURRENT_BINARY_DIR}/../sdk/actions/image/arbitraryslice ${CMAKE_CURRENT_BINARY_DIR}/../sdk/actions/image/cropvolume 
                        ${CMAKE_CURRENT_BINARY_DIR}/../sdk/actions/image/imagelut 
                        ${CMAKE_CURRENT_BINARY_DIR}/../sdk/actions/image/multipicking ${CMAKE_CURRENT_BINARY_DIR}/../sdk/actions/image/reconstruction
                        ${CMAKE_CURRENT_BINARY_DIR}/../sdk/actions/image/volumerendering
        ) #build directories required for ui wrapping includes !

    include_directories(${PROJECT_NAME} ${CAMITK_SDK_INCLUDE_DIR} ${PYSIDE_INCLUDE_ALL_DIR} ${SHIBOKEN_INCLUDE_DIR} ${PYTHON_INCLUDE_PATH} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR} ${VTK_INCLUDE_DIRS} ${CMAKE_CURRENT_BINARY_DIR} ${CAMITK_BUILD_DIR})
    add_library(${PROJECT_NAME} SHARED  ${SDK_WRAPPED_CLASSES}) 
    # # set_property(TARGET ${PROJECT_NAME} PROPERTY PREFIX "")
    set_property(TARGET ${PROJECT_NAME} PROPERTY PREFIX "")
    target_link_libraries(${PROJECT_NAME} ${QT_LIBRARIES} ${VTK_LIBRARIES} ${PYSIDE_LIBRARY} ${SHIBOKEN_PYTHON_LIBRARIES} ${SHIBOKEN_LIBRARY} ${CAMITK_SDK_LIBRARIES})
    # WARNING  check VTK dependency
#     message(WARNING "SHIBOKEN_PYTHON_LIBRARIES = ${SHIBOKEN_PYTHON_LIBRARIES}")
#     message(WARNING "SHIBOKEN_LIBRARY = ${SHIBOKEN_LIBRARY}")
    # add_dependencies(${PROJECT_NAME} camitkcore)  
endif() 


# Create the Python package of CamiTK SDK
# This package is compiled from the generated C++ classes of the sdk_wrap_to_python target 
# and link against the CamiTK SDK libraries.
# Build the custom sdk_package_to_python target in order to compile the wrapped C++ classes and link against
# CamiTK SDK dynamic libraries.
add_custom_target(  sdk_package_to_python
                    COMMAND ${CMAKE_COMMAND} -E echo "Creating Python package of CamiTK SDK."   
                    COMMAND ${CMAKE_COMMAND} ${CMAKE_BINARY_DIR}
                    COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target camitk_sdk
                    COMMAND ${CMAKE_COMMAND} -E echo "CamiTK SDK Python package created." 
                 )
add_dependencies(sdk_package_to_python sdk_wrap_to_python) # need to wrapp before creating the package

=== modeling/actions/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(ACTION_EXTENSION ...) macro appropriately

# find components
get_subdirectories(ACTIONS_LIST)

# Add subdirectories in CMake project
foreach(ACTION_NAME ${ACTIONS_LIST})
  add_subdirectory(${ACTION_NAME})
endforeach()

=== modeling/applications/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add an application, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_application() macro appropriately

# Find applications
get_subdirectories(APPLICATIONS_LIST)

# -- Define for subdirectory usage (test and tools)
# create some useful variables for subdirectories applications
# This lines have to be below the camitk_application macro call
set(LML_DEPENDENCY library${TARGET_NAME_SEPARATOR}lml)
set(LMLSCHEMA_DEPENDENCY library${TARGET_NAME_SEPARATOR}lmlschema)
set(LML_DEPENDENCIES ${LML_DEPENDENCY} ${LMLSCHEMA_DEPENDENCY})
set(PML_DEPENDENCY library${TARGET_NAME_SEPARATOR}pml)
set(PMLSCHEMA_DEPENDENCY library${TARGET_NAME_SEPARATOR}pmlschema)
set(PML_DEPENDENCIES ${PML_DEPENDENCY} ${PMLSCHEMA_DEPENDENCY})
set(PMLLML_DEPENDENCY ${PML_DEPENDENCY} ${PMLSCHEMA_DEPENDENCY} ${LML_DEPENDENCY} ${LMLSCHEMA_DEPENDENCY})

# --- add every given application
foreach(APPLICATION_NAME ${APPLICATIONS_LIST})
   add_subdirectory(${APPLICATION_NAME})
endforeach()

=== modeling/libraries/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a library, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_library() macro appropriately

# --- add every given library in dependencies order
camitk_add_subdirectory(lmlschema)
camitk_add_subdirectory(lml)
camitk_add_subdirectory(pmlschema)
camitk_add_subdirectory(pml)
camitk_add_subdirectory(mmlschema)
camitk_add_subdirectory(mml)

=== python_sdk/actions/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a component, just add a subdirectory (the component name is the
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_extension(ACTION_EXTENSION ...) macro appropriately
#---------------------------------------------------------------------------------
#
# Recursively parse subdirectories for classes to expose 
#
#---------------------------------------------------------------------------------
# Shiboken PATH to look for typesystem.xml adn global.h files, recursively udapted
set(SHIBOKEN_TYPESYSTEM_PATH ${SHIBOKEN_TYPESYSTEM_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
set(SHIBOKEN_GLOBAL_H_PATH ${SHIBOKEN_GLOBAL_H_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")

# find components
get_subdirectories(ACTIONS_MESH_LIST)

# Add subdirectories in CMake project
foreach(ACTION_NAME ${ACTIONS_MESH_LIST})
  add_subdirectory(${ACTION_NAME})
endforeach()

=== python_sdk/libraries/CMakeLists.txt ===
#
# DO NOT EDIT THIS FILE (unless you REALLY know what you are doing)
#
# To add a library, just add a subdirectory (the application name is the 
# directory name). Add all your code there and a text file called
# CMakeLists.txt 
# In your CMakeLists.txt, use the camitk_library() macro appropriately

#---------------------------------------------------------------------------------
#
# Recursively parse subdirectories for classes to expose 
#
#---------------------------------------------------------------------------------
# Shiboken PATH to look for typesystem.xml adn global.h files, recursively udapted
set(SHIBOKEN_TYPESYSTEM_PATH ${SHIBOKEN_TYPESYSTEM_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")
set(SHIBOKEN_GLOBAL_H_PATH ${SHIBOKEN_GLOBAL_H_PATH}:${CMAKE_CURRENT_SOURCE_DIR} CACHE INTERNAL "")

# Find libraries
get_subdirectories(LIBRARY_LIST)

# --- add every given library
foreach(LIB_NAME ${LIBRARY_LIST})
   add_subdirectory(${LIB_NAME})
endforeach()

=== sdk/doc/CMakeLists.txt ===
camitk_add_subdirectory(resources/actions)

=== imaging/actions/itkfilters/CMakeLists.txt ===
if (WIN32)
    if(CMAKE_CL_64)
        # for 64 bits platform, enable big obj (.o) handling, in ordere to correctly compile this (heavy) project
        if (MSVC)
            set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}/bigobj")
            elseif(MINGW)
                set(CMAKE_CXX_FLAGS "-O3 -finline-functions")
            endif()
    endif()
endif()

camitk_extension(   ACTION_EXTENSION
                    NEEDS_ITK
                    CXX_FLAGS "-w"
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This action features basic ITK image processing filters"
                    TEST_APPLICATION ${APPLICATION_TEST_ACTION}
                    DEFINES COMPILE_ITKFILTER_API
                    TEST_FILES bassin.msh BigEndian.hdr BigEndian.img BigEndianCompressed1.hdr BigEndianCompressed1.img brain.mha diaphragm.pml head1.STL LittleEndian1.hdr LittleEndian1.img LittleEndianCompressed1.hdr LittleEndianCompressed1.img LittleEndianZ1.hdr liver-smooth.obj Mesh.off mini-ten-nomask-slow1.nrrd mini-vector-slow1.nrrd mixed_3D_beam.msh ramp1.gipl robot.wrl scissors.obj simple.vtk sinus_skin.vtk sinus_skull.vtk skull1.stl structured.vtk testrgba.nrrd truthcube.pml
)

=== imaging/actions/itksegmentation/CMakeLists.txt ===
camitk_extension(   ACTION_EXTENSION
                    NEEDS_ITK
                    NEEDS_ACTION_EXTENSION multipicking
                    CEP_NAME CEP_IMAGING
                    CXX_FLAGS "-w"
                    DESCRIPTION "This action features basic ITK image processing segmentation algorithms"
                    TEST_APPLICATION ${APPLICATION_TEST_ACTION}
                    TEST_FILES bassin.msh diaphragm.pml head1.STL liver-smooth.obj Mesh.off mixed_3D_beam.msh robot.wrl scissors.obj simple.vtk sinus_skin.vtk sinus_skull.vtk skull1.stl structured.vtk testrgba.nrrd truthcube.pml
)

=== imaging/components/dicom/CMakeLists.txt ===
camitk_extension(   COMPONENT_EXTENSION
                    NEEDS_GDCM
                    CEP_NAME CEP_IMAGING
                    DESCRIPTION "This allows one to read a single DICOM image file (.dcm) using the library GDCM 2.2.x"
                    TEST_APPLICATION ${APPLICATION_TEST_COMPONENT}
                    INSTALL_ALL_HEADERS
)

=== debian/changelog ===
camitk (4.0.4-2ubuntu4) bionic; urgency=medium

  * No-change rebuild for libxerces soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 16 Nov 2017 13:05:00 +0000

camitk (4.0.4-2ubuntu3) artful; urgency=medium

  * No-change rebuild against libgdcm2.8

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 10 Aug 2017 19:18:19 +0000

camitk (4.0.4-2ubuntu2) zesty; urgency=medium

  * Tests: remove one space, at that point it's a newline still..

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 20 Mar 2017 11:10:48 +0200

camitk (4.0.4-2ubuntu1) zesty; urgency=medium

  * Tests: clean config output from QStandardPaths informative text.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 17 Mar 2017 11:29:19 +0200

camitk (4.0.4-2) unstable; urgency=medium

  * Updated email address
  * wizard tests gained verbosity
  * Start Xvfb server first + update test dependencies

 -- Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>  Fri, 20 Jan 2017 20:23:05 +0000

camitk (4.0.4-1) unstable; urgency=medium

  [ Emmanuel Promayon ]
  * New upstream version 4.0.4
  * libdevel needs most of the build depends (needed for ci)

  [ Andreas Tille ]
  * debhelper 10 (drop --parallel from d/rules)
  * d/watch: version=4
  * hardening=+all

 -- Emmanuel Promayon <Emmanuel.Promayon@imag.fr>  Fri, 02 Dec 2016 06:01:44 +0000

=== debian/control ===
Source: camitk
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Emmanuel Promayon <Emmanuel.Promayon@univ-grenoble-alpes.fr>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               libvtk6-dev,
               libvtk6-qt-dev,
               qtbase5-dev,
               libqt5xmlpatterns5-dev,
               libqt5opengl5-dev,
               qttools5-dev-tools,
               xsdcxx,
               libinsighttoolkit4-dev,
               libfftw3-dev,
               libgdcm2-dev,
               libvtkgdcm2-dev,
               xvfb,
               xauth
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/camitk.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/camitk.git
Homepage: http://camitk.imag.fr/
X-Homepage: https://forge.imag.fr/projects/camitk/
Testsuite: autopkgtest

Package: libcamitk4
Architecture: any
Depends: libqtpropertybrowser4 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: camitk-config
Description: Computer Assisted Medical Intervention Tool Kit - runtime
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the shared libraries needed to run CamiTK applications.

Package: camitk-config
Architecture: any
Depends: libcamitk4 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: libcamitk3, libcamitk4 (<< 4.0.3)
Breaks: libcamitk3, libcamitk4 (<< 4.0.3)
Description: Computer Assisted Medical Intervention Tool Kit - config
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains a command-line application to diagnose and check
 the CamiTK configuration and environment setup.

Package: libcamitk-dev
Architecture: any
Section: libdevel
Depends: libcamitk4 (= ${binary:Version}),
         camitk-config,
         libqtpropertybrowser-dev,
         cmake,
         libvtk6-dev,
         libvtk6-qt-dev,
         qtbase5-dev,
         libqt5xmlpatterns5-dev,
         libqt5opengl5-dev,
         qttools5-dev-tools,
         xsdcxx,
         libinsighttoolkit4-dev,
         libfftw3-dev,
         libgdcm2-dev,
         libvtkgdcm2-dev,
         xvfb,
         xauth,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: camitk-imp
Suggests: camitk-actionstatemachine
Breaks: libcamitk3-dev
Replaces: libcamitk3-dev, libcamitk4-dev
Description: Computer Assisted Medical Intervention Tool Kit - development
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains development files needed to build CamiTK applications.
 This package also provides the CamiTK wizard application to create new
 extensions.

Package: libcamitk4-data
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - data
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the examples and test data for CamiTK.

Package: libcamitk4-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Computer Assisted Medical Intervention Tool Kit - documentation
 Helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 This package contains the documentation for CamiTK.

Package: camitk-imp
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: camitk-actionstatemachine
Description: workbench application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-imp is the CamiTK workbench application where you can test
 all available extensions for prototyping.
 It provides an easy and interactive access to all available data and
 algorithm parameters, including the one you build yourself using
 the CamiTK SDK.
 .
 For example, camitk-imp can visualize medical images from a lot of different
 (standard) formats, offers image processing and segmentation algorithms to
 reconstruct a mesh geometry and run a biomechanical simulation.

Package: camitk-actionstatemachine
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: camitk-imp
Description: pipeline replay application for the CamiTK library
 CamiTK helps researchers and clinicians to easily and rapidly collaborate in
 order to prototype CAMI applications, that feature medical images,
 surgical navigation and biomechanical simulations.
 .
 camitk-actionstatemachine is able to replay a pipeline (workflow) of CamiTK
 actions.
 This application takes an CamiTK augmented version of a SCXML subset as input
 and allow on to replay interactive the described state-machine containing a
 list of CamiTK actions and transitions.

Package: libqtpropertybrowser4
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libqtpropertybrowser3
Replaces: libqtpropertybrowser3
Description: Qt Property Browser Library - runtime
 A framework providing a set of graphical editors for
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains the shared libraries needed to run applications
 linked against libqtpropertybrowser4.

Package: libqtpropertybrowser-dev
Architecture: any
Section: libdevel
Depends: libqtpropertybrowser4 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: libqtpropertybrowser3-dev
Replaces: libqtpropertybrowser3-dev, libqtpropertybrowser4-dev
Description: Qt Property Browser Library - development
 A framework providing a set of graphical editors for
 Qt properties similar to the one used in Qt Designer.
 .
 This package contains development files needed to build applications
 using Qt Property Browser

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# CamiTK version from d/changelog)
CHANGELOG_VERSION := $(shell dpkg-parsechangelog -SVersion)
FULL_VERSION := $(shell echo '$(CHANGELOG_VERSION)' | sed -e 's/^[[:digit:]]*://' -e 's/[~-].*//')
VER_MAJOR := $(shell echo '$(FULL_VERSION)' | cut -f1 -d".")
VER_MINOR := $(shell echo '$(FULL_VERSION)' | cut -f2 -d".")
VER_SHORT=$(VER_MAJOR).$(VER_MINOR)

# package aliases (see d/control)
pkg_lib = libcamitk$(VER_MAJOR)
pkg_qpb = libqtpropertybrowser$(VER_MAJOR)
pkg_cfg = camitk-config
pkg_dev = libcamitk-dev
pkg_qpb_dev = libqtpropertybrowser-dev
pkg_data = libcamitk$(VER_MAJOR)-data
pkg_doc = libcamitk$(VER_MAJOR)-doc
pkg_imp = camitk-imp
pkg_asm = camitk-actionstatemachine

# multi-arch support
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# dpkg-shlibdeps needs to know about camitk extension directories to manage inner-dependencies
# between extensions (i.e., mml component extension depends on physicalmodel component extensions)
PKG_LIB_DIR := $(CURDIR)/debian/${pkg_lib}/usr/lib/camitk-${VER_SHORT}
# for component extensions:
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(PKG_LIB_DIR)/components/
# for action extensions:
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(PKG_LIB_DIR)/actions/
# for private libraries:
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(PKG_LIB_DIR)/
# during test, the build dir path is also needed
LIB_BUILD_DIR := $(CURDIR)/camitk-build/lib
PRIVATE_LIB_BUILD_DIR := $(LIB_BUILD_DIR)/camitk-${VER_SHORT}
LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(LIB_BUILD_DIR):$(PRIVATE_LIB_BUILD_DIR)/components/:$(PRIVATE_LIB_BUILD_DIR)/actions/:$(PRIVATE_LIB_BUILD_DIR)/
# export for all d/rules subshell (test and dpkg-shlibdeps included)
export LD_LIBRARY_PATH

# CMake flags are of two types:
# - generic (to tell cmake to build proper binaries)
# - CamiTK specific options
# Notes:
# - if you would like a more verbose camitk at run-time,
#   you can add -DCAMITK_LOG_LEVEL=2
CMAKE_EXTRA_FLAGS = \
	-DCMAKE_SKIP_RPATH:BOOL=TRUE \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH:BOOL=FALSE \
	-DCMAKE_BUILD_TYPE:STRING=None \
	\
	-DCEP_IMAGING:BOOL=TRUE \
	-DCEP_MODELING:BOOL=TRUE \
	\
	-DAPIDOC_SDK:BOOL=TRUE

%:
	dh $@ --builddirectory=camitk-build

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

# let's be smart with doc
override_dh_auto_build-indep:
	$(MAKE) -C camitk-build apidoc
	# remove the javascript search field
	rm -f camitk-build/share/camitk-$(VER_SHORT)/apidoc/html/jquery.js

# No tests needed for docs
override_dh_auto_test-indep:

# run all the available tests (only for Archictecture: any
# as tests can only be run if and once the framework is build)
override_dh_auto_test-arch:
	# Use the CamiTK test suite
	# Note: all tests require an X server, xvfb-run is needed to have a virtual one
	# Another way: xvfb-run --auto-servernum $(MAKE) -C camitk-build ARGS="-V" test
	(cd camitk-build && xvfb-run --auto-servernum --server-args="-screen 0 1024x768x24" ctest -V --timeout 600)

# make packages
override_dh_install:
	# $(CURDIR) is the current source dir
	# camitk dynamic library
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/libcamitkcore.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/libmonitoring.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so.*
	dh_install -p$(pkg_lib) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so.*

	# camitk-config package contains only the app, man page and icon
	dh_install -p$(pkg_cfg) --autodest debian/tmp/usr/bin/camitk-config
	dh_install -p$(pkg_cfg) --autodest debian/tmp/usr/share/pixmaps/camitk-config.xpm
	dh_installman -p$(pkg_cfg) debian/tmp/usr/share/man/man1/camitk-config.1

	# separate packaging for qtpropertybrowser (can be used independently from camitk)
	dh_install -p$(pkg_qpb) --autodest debian/tmp/usr/lib/libqtpropertybrowser.so.*

	# camitk developer package
	# camitk so and headers and static libs
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/libcamitkcore.so usr/lib
	dh_install -p$(pkg_dev) debian/tmp/usr/lib/libmonitoring.so usr/lib
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/actions/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/components/lib*.so
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/camitk-$(VER_SHORT)/lib*.a
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/camitkcore
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/cepcoreschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/cepgenerator
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/actions
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/components
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/pmlschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/pml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/lmlschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/lml
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/mmlschema
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/monitoring
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/monitoringgui
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/packaging/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/cdash/projects/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/test/*.cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/cmake/macros/camitk/test/level/*.cmake
	# wizard
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-wizard
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-wizard.1
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/applications/camitk-wizard.desktop
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/share/pixmaps/camitk-wizard.xpm
	# cepgenerator
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-cepgenerator
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-cepgenerator.1
	# test programs
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-testactions
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-testactions.1
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/camitk-testcomponents
	dh_installman -p$(pkg_dev) debian/tmp/usr/share/man/man1/camitk-testcomponents.1

	# qtpropertybrowser so and headers (includes are put directly in usr/include as package should be generic/independant from CamiTK)
	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/lib/libqtpropertybrowser.so usr/lib
	dh_install -p$(pkg_qpb_dev) debian/tmp/usr/include/camitk-${VER_SHORT}/libraries/qtpropertybrowser usr/include

	# api doc
	dh_install -p$(pkg_doc) --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/apidoc

	# all test data excluding extra licence files (everything is already specified in d/c)
	dh_install -p$(pkg_data) --exclude=LICENSE --autodest debian/tmp/usr/share/camitk-$(VER_SHORT)/testdata

	# imp
	dh_install -p$(pkg_imp) --autodest debian/tmp/usr/bin/camitk-imp
	dh_install -p$(pkg_imp) --autodest debian/tmp/usr/share/applications/camitk-imp.desktop

=== debian/watch ===
version=4
http://camitk.imag.fr/devDownload.php .*/camitk-(\d.*?)(?:-.*)?\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
